      PROGRAM ORG__MAIN___
      INCLUDE 'mpif.h'
      EXTERNAL ORG___MAIN___
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTEGER(KIND=4):: ierrX0
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      CALL mpi_init(ierrX0)
      CALL mpi_comm_rank(MPI_COMM_WORLD,ORG_RANK,ierrX0)
      CALL mpi_comm_size(MPI_COMM_WORLD,ORG_SIZE,ierrX0)
      CALL ORG___MAIN___()
      CALL mpi_finalize(ierrX0)
      END PROGRAM
      SUBROUTINE ORG___MAIN___()
      INCLUDE 'mpif.h'
      REAL(KIND=4), POINTER:: a(:,:,:,:)
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      INTEGER(KIND=4):: npi
      PARAMETER (npi=2)
      INTEGER(KIND=4):: npj
      PARAMETER (npj=2)
      INTEGER(KIND=4):: npk
      PARAMETER (npk=4)
      INTEGER(KIND=4):: npe
      PARAMETER (npe=npi*npj*npk)
      REAL(KIND=4), POINTER:: p(:,:,:)
      REAL(KIND=4), POINTER:: b(:,:,:,:)
      REAL(KIND=4), POINTER:: c(:,:,:,:)
      REAL(KIND=4), POINTER:: bnd(:,:,:)
      REAL(KIND=4), POINTER:: wrk1(:,:,:)
      REAL(KIND=4), POINTER:: wrk2(:,:,:)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      REAL(KIND=4):: ttarget
      PARAMETER (ttarget=60.0e0)
      REAL(KIND=4):: time0(1:2)
      REAL(KIND=4):: time1(1:2)
      EXTERNAL initmt
      INTEGER(KIND=4):: nn
      REAL(KIND=4):: cpu0
      EXTERNAL gdtime
      REAL(KIND=4):: gdtime
      EXTERNAL jacobi
      REAL(KIND=4):: gosa
      REAL(KIND=4):: cpu1
      REAL(KIND=4):: cpu
      REAL(KIND=4):: flop
      INTRINSIC real
      REAL(KIND=4):: xmflops2
      INTRINSIC ifix
      REAL(KIND=4):: score
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTEGER(KIND=4):: ierrX0
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /workX1/wrk2
      COMMON /workX0/wrk1
      COMMON /boundX0/bnd
      COMMON /mtrxX2/c
      COMMON /mtrxX1/b
      COMMON /mtrxX0/a
      COMMON /presX0/p
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      IF (.NOT.(associated(wrk2))) ALLOCATE (wrk2(0:128,0:64,0:32))
      IF (.NOT.(associated(wrk1))) ALLOCATE (wrk1(0:128,0:64,0:32))
      IF (.NOT.(associated(bnd))) ALLOCATE (bnd(0:128,0:64,0:32))
      IF (.NOT.(associated(c))) ALLOCATE (c(0:128,0:64,0:32,1:3))
      IF (.NOT.(associated(b))) ALLOCATE (b(0:128,0:64,0:32,1:3))
      IF (.NOT.(associated(p))) ALLOCATE (p(-1:129,-1:65,-1:33))
      IF (.NOT.(associated(a))) ALLOCATE (a(0:128,0:64,0:32,1:4))
      omega = 0.8e0
      imax = 256
      jmax = 128
      kmax = 128
      CALL initmt()
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' mimax=',257,' mjmax=',1&
     &29,' mkmax=',129
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' imax=',imax,' jmax=',jm&
     &ax,' kmax=',kmax
      nn = 3
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Start rehearsal measure&
     &ment process.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Measure the performance&
     & in 3 times.'
      cpu0 = gdtime(time0)
      CALL jacobi(nn,gosa)
      cpu1 = gdtime(time1)
      cpu = cpu1
      flop = (real(kmax-2))*(real(jmax-2))*(real(imax-2))*(34.0e0)*(real&
     &(nn))
      xmflops2 = flop/cpu*(1.0E-6)
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) '  MFLOPS:',xmflops2,'  t&
     &ime(s):',cpu,gosa
      nn = ifix(ttarget/(cpu/(3.0e0)))
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'Now, start the actual me&
     &asurement process.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'The loop will be excuted&
     & in',nn,' times.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'This will take about one&
     & minute.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'Wait for a while.'
      cpu0 = gdtime(time0)
      CALL jacobi(nn,gosa)
      cpu1 = gdtime(time1)
      cpu = cpu1
      flop = (real(kmax-2))*(real(jmax-2))*(real(imax-2))*(34.0e0)*(real&
     &(nn))
      xmflops2 = flop*(1.0E-6)/cpu
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Loop executed for ',nn,&
     &' times'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Gosa :',gosa
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' MFLOPS:',xmflops2,'  ti&
     &me(s):',cpu
      score = xmflops2/(82.84e0)
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Score based on Pentium &
     &III 600MHz :',score
      RETURN
      END SUBROUTINE
      SUBROUTINE initmt()
      INCLUDE 'mpif.h'
      REAL(KIND=4), POINTER:: a(:,:,:,:)
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      INTEGER(KIND=4):: npi
      PARAMETER (npi=2)
      INTEGER(KIND=4):: npj
      PARAMETER (npj=2)
      INTEGER(KIND=4):: npk
      PARAMETER (npk=4)
      INTEGER(KIND=4):: npe
      PARAMETER (npe=npi*npj*npk)
      REAL(KIND=4), POINTER:: p(:,:,:)
      REAL(KIND=4), POINTER:: b(:,:,:,:)
      REAL(KIND=4), POINTER:: c(:,:,:,:)
      REAL(KIND=4), POINTER:: bnd(:,:,:)
      REAL(KIND=4), POINTER:: wrk1(:,:,:)
      REAL(KIND=4), POINTER:: wrk2(:,:,:)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      INTEGER(KIND=4):: j
      INTEGER(KIND=4):: k
      INTEGER(KIND=4):: i
      INTRINSIC float
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTRINSIC mod
      INTEGER(KIND=4):: spmdX0
      INTEGER(KIND=4):: spmdX1
      INTEGER(KIND=4):: spmd_startX0
      INTEGER(KIND=4):: spmd_endX0
      INTEGER(KIND=4):: spmd_stepX0
      INTEGER(KIND=4):: spmdX2
      INTEGER(KIND=4):: spmdX3
      INTEGER(KIND=4):: spmd_startX1
      INTEGER(KIND=4):: spmd_endX1
      INTEGER(KIND=4):: spmd_stepX1
      INTEGER(KIND=4):: spmdX4
      INTEGER(KIND=4):: spmdX5
      INTEGER(KIND=4):: spmd_startX2
      INTEGER(KIND=4):: spmd_endX2
      INTEGER(KIND=4):: spmd_stepX2
      INTEGER(KIND=4):: spmdX6
      INTEGER(KIND=4):: spmdX7
      INTEGER(KIND=4):: spmd_startX3
      INTEGER(KIND=4):: spmd_endX3
      INTEGER(KIND=4):: spmd_stepX3
      INTEGER(KIND=4):: spmdX8
      INTEGER(KIND=4):: spmdX9
      INTEGER(KIND=4):: spmd_startX4
      INTEGER(KIND=4):: spmd_endX4
      INTEGER(KIND=4):: spmd_stepX4
      INTEGER(KIND=4):: spmdX10
      INTEGER(KIND=4):: spmdX11
      INTEGER(KIND=4):: spmd_startX5
      INTEGER(KIND=4):: spmd_endX5
      INTEGER(KIND=4):: spmd_stepX5
      INTEGER(KIND=4):: ierrX0
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /workX1/wrk2
      COMMON /workX0/wrk1
      COMMON /boundX0/bnd
      COMMON /mtrxX2/c
      COMMON /mtrxX1/b
      COMMON /mtrxX0/a
      COMMON /presX0/p
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      IF (.NOT.(associated(wrk2))) ALLOCATE (wrk2(0:128,0:64,0:32))
      IF (.NOT.(associated(wrk1))) ALLOCATE (wrk1(0:128,0:64,0:32))
      IF (.NOT.(associated(bnd))) ALLOCATE (bnd(0:128,0:64,0:32))
      IF (.NOT.(associated(c))) ALLOCATE (c(0:128,0:64,0:32,1:3))
      IF (.NOT.(associated(b))) ALLOCATE (b(0:128,0:64,0:32,1:3))
      IF (.NOT.(associated(p))) ALLOCATE (p(-1:129,-1:65,-1:33))
      IF (.NOT.(associated(a))) ALLOCATE (a(0:128,0:64,0:32,1:4))
      spmdX0 = (mod(ORG_RANK,16))/4
      spmdX1 = 33*spmdX0
      IF (spmdX0.LE.0) THEN
        spmd_startX0 = -spmdX1
      ELSE
        spmd_startX0 = 0
      ENDIF
      IF (spmdX0.LT.3) THEN
        spmd_endX0 = 32
      ELSE
        spmd_endX0 = 128-spmdX1
      ENDIF
      spmd_stepX0 = 1
      spmdX2 = (mod(ORG_RANK,4))/2
      spmdX3 = 65*spmdX2
      IF (spmdX2.LE.0) THEN
        spmd_startX1 = -spmdX3
      ELSE
        spmd_startX1 = 0
      ENDIF
      IF (spmdX2.LT.1) THEN
        spmd_endX1 = 64
      ELSE
        spmd_endX1 = 128-spmdX3
      ENDIF
      spmd_stepX1 = 1
      spmdX4 = mod(ORG_RANK,2)
      spmdX5 = 129*spmdX4
      IF (spmdX4.LE.0) THEN
        spmd_startX2 = -spmdX5
      ELSE
        spmd_startX2 = 0
      ENDIF
      IF (spmdX4.LT.1) THEN
        spmd_endX2 = 128
      ELSE
        spmd_endX2 = 256-spmdX5
      ENDIF
      spmd_stepX2 = 1
      DO k=spmd_startX0,spmd_endX0,1
        DO j=spmd_startX1,spmd_endX1,1
          DO i=spmd_startX2,spmd_endX2,1
            a(i,j,k,1) = 0.0e0
            a(i,j,k,2) = 0.0e0
            a(i,j,k,3) = 0.0e0
            a(i,j,k,4) = 0.0e0
            b(i,j,k,1) = 0.0e0
            b(i,j,k,2) = 0.0e0
            b(i,j,k,3) = 0.0e0
            c(i,j,k,1) = 0.0e0
            c(i,j,k,2) = 0.0e0
            c(i,j,k,3) = 0.0e0
            p(i,j,k) = 0.0e0
            wrk1(i,j,k) = 0.0e0
            bnd(i,j,k) = 0.0e0
          ENDDO
        ENDDO
      ENDDO
      spmdX6 = (mod(ORG_RANK,16))/4
      spmdX7 = 33*spmdX6
      IF (spmdX6.LE.0) THEN
        spmd_startX3 = -spmdX7
      ELSE
        spmd_startX3 = 0
      ENDIF
      IF (spmdX6.LT.(kmax-1)/33) THEN
        spmd_endX3 = 32
      ELSE
        spmd_endX3 = kmax-1-spmdX7
      ENDIF
      spmd_stepX3 = 1
      spmdX8 = (mod(ORG_RANK,4))/2
      spmdX9 = 65*spmdX8
      IF (spmdX8.LE.0) THEN
        spmd_startX4 = -spmdX9
      ELSE
        spmd_startX4 = 0
      ENDIF
      IF (spmdX8.LT.(jmax-1)/65) THEN
        spmd_endX4 = 64
      ELSE
        spmd_endX4 = jmax-1-spmdX9
      ENDIF
      spmd_stepX4 = 1
      spmdX10 = mod(ORG_RANK,2)
      spmdX11 = 129*spmdX10
      IF (spmdX10.LE.0) THEN
        spmd_startX5 = -spmdX11
      ELSE
        spmd_startX5 = 0
      ENDIF
      IF (spmdX10.LT.(imax-1)/129) THEN
        spmd_endX5 = 128
      ELSE
        spmd_endX5 = imax-1-spmdX11
      ENDIF
      spmd_stepX5 = 1
      DO k=spmd_startX3,spmd_endX3,1
        DO j=spmd_startX4,spmd_endX4,1
          DO i=spmd_startX5,spmd_endX5,1
            a(i,j,k,1) = 1.0e0
            a(i,j,k,2) = 1.0e0
            a(i,j,k,3) = 1.0e0
            a(i,j,k,4) = (1.0e0)/(6.0e0)
            b(i,j,k,1) = 0.0e0
            b(i,j,k,2) = 0.0e0
            b(i,j,k,3) = 0.0e0
            c(i,j,k,1) = 1.0e0
            c(i,j,k,2) = 1.0e0
            c(i,j,k,3) = 1.0e0
            p(i,j,k) = (float(k*k+2*spmdX7*k+spmdX7*spmdX7))/(float(kmax&
     &*kmax-2*kmax+1))
            wrk1(i,j,k) = 0.0e0
            bnd(i,j,k) = 1.0e0
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END SUBROUTINE
      SUBROUTINE jacobi(nn,gosa)
      INCLUDE 'mpif.h'
      INTEGER(KIND=4):: nn
      REAL(KIND=4):: gosa
      REAL(KIND=4), POINTER:: a(:,:,:,:)
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      INTEGER(KIND=4):: npi
      PARAMETER (npi=2)
      INTEGER(KIND=4):: npj
      PARAMETER (npj=2)
      INTEGER(KIND=4):: npk
      PARAMETER (npk=4)
      INTEGER(KIND=4):: npe
      PARAMETER (npe=npi*npj*npk)
      REAL(KIND=4), POINTER:: p(:,:,:)
      REAL(KIND=4), POINTER:: b(:,:,:,:)
      REAL(KIND=4), POINTER:: c(:,:,:,:)
      REAL(KIND=4), POINTER:: bnd(:,:,:)
      REAL(KIND=4), POINTER:: wrk1(:,:,:)
      REAL(KIND=4), POINTER:: wrk2(:,:,:)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      INTEGER(KIND=4):: loop
      INTEGER(KIND=4):: j
      INTEGER(KIND=4):: k
      INTEGER(KIND=4):: i
      REAL(KIND=4):: s0
      REAL(KIND=4):: ss
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTRINSIC mod
      INTEGER(KIND=4):: spmdX0
      INTEGER(KIND=4):: spmdX1
      INTEGER(KIND=4):: spmd_startX0
      INTEGER(KIND=4):: spmd_endX0
      INTEGER(KIND=4):: spmd_stepX0
      INTEGER(KIND=4):: spmdX2
      INTEGER(KIND=4):: spmdX3
      INTEGER(KIND=4):: spmd_startX1
      INTEGER(KIND=4):: spmd_endX1
      INTEGER(KIND=4):: spmd_stepX1
      INTEGER(KIND=4):: spmdX4
      INTEGER(KIND=4):: spmdX5
      INTEGER(KIND=4):: spmd_startX2
      INTEGER(KIND=4):: spmd_endX2
      INTEGER(KIND=4):: spmd_stepX2
      INTEGER(KIND=4):: spmdX6
      INTEGER(KIND=4):: spmdX7
      INTEGER(KIND=4):: spmd_startX3
      INTEGER(KIND=4):: spmd_endX3
      INTEGER(KIND=4):: spmd_stepX3
      INTEGER(KIND=4):: spmdX8
      INTEGER(KIND=4):: spmdX9
      INTEGER(KIND=4):: spmd_startX4
      INTEGER(KIND=4):: spmd_endX4
      INTEGER(KIND=4):: spmd_stepX4
      INTEGER(KIND=4):: spmdX10
      INTEGER(KIND=4):: spmdX11
      INTEGER(KIND=4):: spmd_startX5
      INTEGER(KIND=4):: spmd_endX5
      INTEGER(KIND=4):: spmd_stepX5
      INTEGER(KIND=4):: ierrX0
      INTEGER(KIND=4):: localidX0
      INTEGER(KIND=4):: accessidX0
      INTEGER(KIND=4):: distX0
      INTEGER(KIND=4):: distX1
      INTEGER(KIND=4), ALLOCATABLE:: ireqX0(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX1(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX2(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX3(:)
      INTEGER(KIND=4):: ierrX1
      INTEGER(KIND=4):: statusX0(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX1(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX2(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX3(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      REAL(KIND=4), ALLOCATABLE:: sendlX0(:,:)
      REAL(KIND=4), ALLOCATABLE:: sendrX0(:,:)
      REAL(KIND=4), ALLOCATABLE:: recvlX0(:,:)
      REAL(KIND=4), ALLOCATABLE:: recvrX0(:,:)
      INTEGER(KIND=4):: indexX0
      INTEGER(KIND=4):: indexX1
      INTEGER(KIND=4):: indexX2
      INTEGER(KIND=4):: indexX3
      INTEGER(KIND=4):: indexX4
      INTRINSIC abs
      INTEGER(KIND=4):: lsizeX0
      INTRINSIC min
      INTEGER(KIND=4):: rsizeX0
      INTEGER(KIND=4):: localidX1
      INTEGER(KIND=4):: accessidX1
      INTEGER(KIND=4):: distX2
      INTEGER(KIND=4):: distX3
      INTEGER(KIND=4), ALLOCATABLE:: ireqX4(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX5(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX6(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX7(:)
      INTEGER(KIND=4):: ierrX2
      INTEGER(KIND=4):: statusX4(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX5(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX6(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX7(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      REAL(KIND=4), ALLOCATABLE:: sendlX1(:,:)
      REAL(KIND=4), ALLOCATABLE:: sendrX1(:,:)
      REAL(KIND=4), ALLOCATABLE:: recvlX1(:,:)
      REAL(KIND=4), ALLOCATABLE:: recvrX1(:,:)
      INTEGER(KIND=4):: indexX5
      INTEGER(KIND=4):: indexX6
      INTEGER(KIND=4):: indexX7
      INTEGER(KIND=4):: indexX8
      INTEGER(KIND=4):: indexX9
      INTEGER(KIND=4):: lsizeX1
      INTEGER(KIND=4):: rsizeX1
      INTEGER(KIND=4):: localidX2
      INTEGER(KIND=4):: accessidX2
      INTEGER(KIND=4):: distX4
      INTEGER(KIND=4):: distX5
      INTEGER(KIND=4), ALLOCATABLE:: ireqX8(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX9(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX10(:)
      INTEGER(KIND=4), ALLOCATABLE:: ireqX11(:)
      INTEGER(KIND=4):: ierrX3
      INTEGER(KIND=4):: statusX8(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX9(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX10(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      INTEGER(KIND=4):: statusX11(1:MPI_STATUS_SIZE,0:ORG_SIZE-1)
      REAL(KIND=4), ALLOCATABLE:: sendlX2(:,:)
      REAL(KIND=4), ALLOCATABLE:: sendrX2(:,:)
      REAL(KIND=4), ALLOCATABLE:: recvlX2(:,:)
      REAL(KIND=4), ALLOCATABLE:: recvrX2(:,:)
      INTEGER(KIND=4):: indexX10
      INTEGER(KIND=4):: indexX11
      INTEGER(KIND=4):: indexX12
      INTEGER(KIND=4):: indexX13
      INTEGER(KIND=4):: indexX14
      INTEGER(KIND=4):: lsizeX2
      INTEGER(KIND=4):: rsizeX2
      INTEGER(KIND=4):: new_commX0
      INTEGER(KIND=4):: ierrX4
      REAL(KIND=4):: gosaX0
      REAL(KIND=4):: recvbufX0
      INTEGER(KIND=4):: ierrX5
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /workX1/wrk2
      COMMON /workX0/wrk1
      COMMON /boundX0/bnd
      COMMON /mtrxX2/c
      COMMON /mtrxX1/b
      COMMON /mtrxX0/a
      COMMON /presX0/p
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      IF (.NOT.(associated(wrk2))) ALLOCATE (wrk2(0:128,0:64,0:32))
      IF (.NOT.(associated(wrk1))) ALLOCATE (wrk1(0:128,0:64,0:32))
      IF (.NOT.(associated(bnd))) ALLOCATE (bnd(0:128,0:64,0:32))
      IF (.NOT.(associated(c))) ALLOCATE (c(0:128,0:64,0:32,1:3))
      IF (.NOT.(associated(b))) ALLOCATE (b(0:128,0:64,0:32,1:3))
      IF (.NOT.(associated(p))) ALLOCATE (p(-1:129,-1:65,-1:33))
      IF (.NOT.(associated(a))) ALLOCATE (a(0:128,0:64,0:32,1:4))
      DO loop=1,nn,1
        gosa = 0.0e0
        CONTINUE
        ALLOCATE (ireqX0(0:ORG_SIZE-1),ireqX1(0:ORG_SIZE-1),ireqX2(0:ORG&
     &_SIZE-1),ireqX3(0:ORG_SIZE-1),sendlX0(1:2345,0:ORG_SIZE-1),sendrX0&
     &(1:2345,0:ORG_SIZE-1),recvlX0(1:2345,0:ORG_SIZE-1),recvrX0(1:2345,&
     &0:ORG_SIZE-1))
        localidX0 = mod(ORG_RANK,2)
        DO indexX4=0,ORG_SIZE-1,1
          ireqX0(indexX4) = MPI_REQUEST_NULL
          ireqX2(indexX4) = MPI_REQUEST_NULL
          ireqX1(indexX4) = MPI_REQUEST_NULL
          ireqX3(indexX4) = MPI_REQUEST_NULL
        ENDDO
        DO indexX4=0,1,1
          IF (localidX0.EQ.indexX4) CYCLE
          distX0 = abs(indexX4-localidX0)
          distX1 = indexX4-localidX0
          accessidX0 = ORG_RANK+distX1
          lsizeX0 = min(130-129*distX0,129)
          rsizeX0 = min(130-129*distX0,129)
          IF ((indexX4.GT.localidX0).AND.(lsizeX0.GT.0)) THEN
            indexX3 = 1
            DO indexX2=-1,33,1
              DO indexX1=-1,65,1
                DO indexX0=129-lsizeX0,128,1
                  sendlX0(indexX3,indexX4) = p(indexX0,indexX1,indexX2)
                  indexX3 = indexX3+1
                ENDDO
              ENDDO
            ENDDO
            CALL MPI_Isend(sendlX0(1,indexX4),2345*lsizeX0,MPI_REAL4,acc&
     &essidX0,100,MPI_COMM_WORLD,ireqX0(indexX4),ierrX1)
          ENDIF
          IF ((indexX4.LT.localidX0).AND.(rsizeX0.GT.0)) THEN
            indexX3 = 1
            DO indexX2=-1,33,1
              DO indexX1=-1,65,1
                DO indexX0=0,-1+rsizeX0,1
                  sendrX0(indexX3,indexX4) = p(indexX0,indexX1,indexX2)
                  indexX3 = indexX3+1
                ENDDO
              ENDDO
            ENDDO
            CALL MPI_Isend(sendrX0(1,indexX4),2345*rsizeX0,MPI_REAL4,acc&
     &essidX0,100,MPI_COMM_WORLD,ireqX1(indexX4),ierrX1)
          ENDIF
          IF ((indexX4.LT.localidX0).AND.(lsizeX0.GT.0)) CALL MPI_Irecv(&
     &recvlX0(1,indexX4),2345*lsizeX0,MPI_REAL4,accessidX0,100,MPI_COMM_&
     &WORLD,ireqX2(indexX4),ierrX1)
          IF ((indexX4.GT.localidX0).AND.(rsizeX0.GT.0)) CALL MPI_Irecv(&
     &recvrX0(1,indexX4),2345*rsizeX0,MPI_REAL4,accessidX0,100,MPI_COMM_&
     &WORLD,ireqX3(indexX4),ierrX1)
        ENDDO
        CALL MPI_Waitall(ORG_SIZE,ireqX0,statusX0,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX1,statusX1,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX2,statusX2,ierrX1)
        CALL MPI_Waitall(ORG_SIZE,ireqX3,statusX3,ierrX1)
        DO indexX4=0,1,1
          IF (localidX0.EQ.indexX4) CYCLE
          distX0 = abs(indexX4-localidX0)
          lsizeX0 = min(130-129*distX0,129)
          rsizeX0 = min(130-129*distX0,129)
          IF ((indexX4.LT.localidX0).AND.(lsizeX0.GT.0)) THEN
            indexX3 = 1
            DO indexX2=-1,33,1
              DO indexX1=-1,65,1
                DO indexX0=-129*distX0+129-lsizeX0,128-129*distX0,1
                  p(indexX0,indexX1,indexX2) = recvlX0(indexX3,indexX4)
                  indexX3 = indexX3+1
                ENDDO
              ENDDO
            ENDDO
          ENDIF
          IF ((indexX4.GT.localidX0).AND.(rsizeX0.GT.0)) THEN
            indexX3 = 1
            DO indexX2=-1,33,1
              DO indexX1=-1,65,1
                DO indexX0=129*distX0,-1+129*distX0+rsizeX0,1
                  p(indexX0,indexX1,indexX2) = recvrX0(indexX3,indexX4)
                  indexX3 = indexX3+1
                ENDDO
              ENDDO
            ENDDO
          ENDIF
        ENDDO
        DEALLOCATE (ireqX0,ireqX1,ireqX2,ireqX3,sendlX0,sendrX0,recvlX0,&
     &recvrX0)
        ALLOCATE (ireqX4(0:ORG_SIZE-1),ireqX5(0:ORG_SIZE-1),ireqX6(0:ORG&
     &_SIZE-1),ireqX7(0:ORG_SIZE-1),sendlX1(1:4585,0:ORG_SIZE-1),sendrX1&
     &(1:4585,0:ORG_SIZE-1),recvlX1(1:4585,0:ORG_SIZE-1),recvrX1(1:4585,&
     &0:ORG_SIZE-1))
        localidX1 = (mod(ORG_RANK,4))/2
        DO indexX9=0,ORG_SIZE-1,1
          ireqX4(indexX9) = MPI_REQUEST_NULL
          ireqX6(indexX9) = MPI_REQUEST_NULL
          ireqX5(indexX9) = MPI_REQUEST_NULL
          ireqX7(indexX9) = MPI_REQUEST_NULL
        ENDDO
        DO indexX9=0,1,1
          IF (localidX1.EQ.indexX9) CYCLE
          distX2 = abs(indexX9-localidX1)
          distX3 = indexX9-localidX1
          accessidX1 = ORG_RANK+2*distX3
          lsizeX1 = min(66-65*distX2,65)
          rsizeX1 = min(66-65*distX2,65)
          IF ((indexX9.GT.localidX1).AND.(lsizeX1.GT.0)) THEN
            indexX8 = 1
            DO indexX7=-1,33,1
              DO indexX6=65-lsizeX1,64,1
                DO indexX5=-1,129,1
                  sendlX1(indexX8,indexX9) = p(indexX5,indexX6,indexX7)
                  indexX8 = indexX8+1
                ENDDO
              ENDDO
            ENDDO
            CALL MPI_Isend(sendlX1(1,indexX9),4585*lsizeX1,MPI_REAL4,acc&
     &essidX1,101,MPI_COMM_WORLD,ireqX4(indexX9),ierrX2)
          ENDIF
          IF ((indexX9.LT.localidX1).AND.(rsizeX1.GT.0)) THEN
            indexX8 = 1
            DO indexX7=-1,33,1
              DO indexX6=0,-1+rsizeX1,1
                DO indexX5=-1,129,1
                  sendrX1(indexX8,indexX9) = p(indexX5,indexX6,indexX7)
                  indexX8 = indexX8+1
                ENDDO
              ENDDO
            ENDDO
            CALL MPI_Isend(sendrX1(1,indexX9),4585*rsizeX1,MPI_REAL4,acc&
     &essidX1,101,MPI_COMM_WORLD,ireqX5(indexX9),ierrX2)
          ENDIF
          IF ((indexX9.LT.localidX1).AND.(lsizeX1.GT.0)) CALL MPI_Irecv(&
     &recvlX1(1,indexX9),4585*lsizeX1,MPI_REAL4,accessidX1,101,MPI_COMM_&
     &WORLD,ireqX6(indexX9),ierrX2)
          IF ((indexX9.GT.localidX1).AND.(rsizeX1.GT.0)) CALL MPI_Irecv(&
     &recvrX1(1,indexX9),4585*rsizeX1,MPI_REAL4,accessidX1,101,MPI_COMM_&
     &WORLD,ireqX7(indexX9),ierrX2)
        ENDDO
        CALL MPI_Waitall(ORG_SIZE,ireqX4,statusX4,ierrX2)
        CALL MPI_Waitall(ORG_SIZE,ireqX5,statusX5,ierrX2)
        CALL MPI_Waitall(ORG_SIZE,ireqX6,statusX6,ierrX2)
        CALL MPI_Waitall(ORG_SIZE,ireqX7,statusX7,ierrX2)
        DO indexX9=0,1,1
          IF (localidX1.EQ.indexX9) CYCLE
          distX2 = abs(indexX9-localidX1)
          lsizeX1 = min(66-65*distX2,65)
          rsizeX1 = min(66-65*distX2,65)
          IF ((indexX9.LT.localidX1).AND.(lsizeX1.GT.0)) THEN
            indexX8 = 1
            DO indexX7=-1,33,1
              DO indexX6=-65*distX2+65-lsizeX1,64-65*distX2,1
                DO indexX5=-1,129,1
                  p(indexX5,indexX6,indexX7) = recvlX1(indexX8,indexX9)
                  indexX8 = indexX8+1
                ENDDO
              ENDDO
            ENDDO
          ENDIF
          IF ((indexX9.GT.localidX1).AND.(rsizeX1.GT.0)) THEN
            indexX8 = 1
            DO indexX7=-1,33,1
              DO indexX6=65*distX2,-1+65*distX2+rsizeX1,1
                DO indexX5=-1,129,1
                  p(indexX5,indexX6,indexX7) = recvrX1(indexX8,indexX9)
                  indexX8 = indexX8+1
                ENDDO
              ENDDO
            ENDDO
          ENDIF
        ENDDO
        DEALLOCATE (ireqX4,ireqX5,ireqX6,ireqX7,sendlX1,sendrX1,recvlX1,&
     &recvrX1)
        ALLOCATE (ireqX8(0:ORG_SIZE-1),ireqX9(0:ORG_SIZE-1),ireqX10(0:OR&
     &G_SIZE-1),ireqX11(0:ORG_SIZE-1),sendlX2(1:8777,0:ORG_SIZE-1),sendr&
     &X2(1:8777,0:ORG_SIZE-1),recvlX2(1:8777,0:ORG_SIZE-1),recvrX2(1:877&
     &7,0:ORG_SIZE-1))
        localidX2 = (mod(ORG_RANK,16))/4
        DO indexX14=0,ORG_SIZE-1,1
          ireqX8(indexX14) = MPI_REQUEST_NULL
          ireqX10(indexX14) = MPI_REQUEST_NULL
          ireqX9(indexX14) = MPI_REQUEST_NULL
          ireqX11(indexX14) = MPI_REQUEST_NULL
        ENDDO
        DO indexX14=0,3,1
          IF (localidX2.EQ.indexX14) CYCLE
          distX4 = abs(indexX14-localidX2)
          distX5 = indexX14-localidX2
          accessidX2 = ORG_RANK+4*distX5
          lsizeX2 = min(34-33*distX4,33)
          rsizeX2 = min(34-33*distX4,33)
          IF ((indexX14.GT.localidX2).AND.(lsizeX2.GT.0)) THEN
            indexX13 = 1
            DO indexX12=33-lsizeX2,32,1
              DO indexX11=-1,65,1
                DO indexX10=-1,129,1
                  sendlX2(indexX13,indexX14) = p(indexX10,indexX11,index&
     &X12)
                  indexX13 = indexX13+1
                ENDDO
              ENDDO
            ENDDO
            CALL MPI_Isend(sendlX2(1,indexX14),8777*lsizeX2,MPI_REAL4,ac&
     &cessidX2,102,MPI_COMM_WORLD,ireqX8(indexX14),ierrX3)
          ENDIF
          IF ((indexX14.LT.localidX2).AND.(rsizeX2.GT.0)) THEN
            indexX13 = 1
            DO indexX12=0,-1+rsizeX2,1
              DO indexX11=-1,65,1
                DO indexX10=-1,129,1
                  sendrX2(indexX13,indexX14) = p(indexX10,indexX11,index&
     &X12)
                  indexX13 = indexX13+1
                ENDDO
              ENDDO
            ENDDO
            CALL MPI_Isend(sendrX2(1,indexX14),8777*rsizeX2,MPI_REAL4,ac&
     &cessidX2,102,MPI_COMM_WORLD,ireqX9(indexX14),ierrX3)
          ENDIF
          IF ((indexX14.LT.localidX2).AND.(lsizeX2.GT.0)) CALL MPI_Irecv&
     &(recvlX2(1,indexX14),8777*lsizeX2,MPI_REAL4,accessidX2,102,MPI_COM&
     &M_WORLD,ireqX10(indexX14),ierrX3)
          IF ((indexX14.GT.localidX2).AND.(rsizeX2.GT.0)) CALL MPI_Irecv&
     &(recvrX2(1,indexX14),8777*rsizeX2,MPI_REAL4,accessidX2,102,MPI_COM&
     &M_WORLD,ireqX11(indexX14),ierrX3)
        ENDDO
        CALL MPI_Waitall(ORG_SIZE,ireqX8,statusX8,ierrX3)
        CALL MPI_Waitall(ORG_SIZE,ireqX9,statusX9,ierrX3)
        CALL MPI_Waitall(ORG_SIZE,ireqX10,statusX10,ierrX3)
        CALL MPI_Waitall(ORG_SIZE,ireqX11,statusX11,ierrX3)
        DO indexX14=0,3,1
          IF (localidX2.EQ.indexX14) CYCLE
          distX4 = abs(indexX14-localidX2)
          lsizeX2 = min(34-33*distX4,33)
          rsizeX2 = min(34-33*distX4,33)
          IF ((indexX14.LT.localidX2).AND.(lsizeX2.GT.0)) THEN
            indexX13 = 1
            DO indexX12=-33*distX4+33-lsizeX2,32-33*distX4,1
              DO indexX11=-1,65,1
                DO indexX10=-1,129,1
                  p(indexX10,indexX11,indexX12) = recvlX2(indexX13,index&
     &X14)
                  indexX13 = indexX13+1
                ENDDO
              ENDDO
            ENDDO
          ENDIF
          IF ((indexX14.GT.localidX2).AND.(rsizeX2.GT.0)) THEN
            indexX13 = 1
            DO indexX12=33*distX4,-1+33*distX4+rsizeX2,1
              DO indexX11=-1,65,1
                DO indexX10=-1,129,1
                  p(indexX10,indexX11,indexX12) = recvrX2(indexX13,index&
     &X14)
                  indexX13 = indexX13+1
                ENDDO
              ENDDO
            ENDDO
          ENDIF
        ENDDO
        DEALLOCATE (ireqX8,ireqX9,ireqX10,ireqX11,sendlX2,sendrX2,recvlX&
     &2,recvrX2)
        spmdX0 = (mod(ORG_RANK,16))/4
        spmdX1 = 33*spmdX0
        IF (spmdX0.LE.0) THEN
          spmd_startX0 = 1-spmdX1
        ELSE
          spmd_startX0 = 0
        ENDIF
        IF (spmdX0.LT.(kmax-2)/33) THEN
          spmd_endX0 = 32
        ELSE
          spmd_endX0 = kmax-2-spmdX1
        ENDIF
        spmd_stepX0 = 1
        spmdX2 = (mod(ORG_RANK,4))/2
        spmdX3 = 65*spmdX2
        IF (spmdX2.LE.0) THEN
          spmd_startX1 = 1-spmdX3
        ELSE
          spmd_startX1 = 0
        ENDIF
        IF (spmdX2.LT.(jmax-2)/65) THEN
          spmd_endX1 = 64
        ELSE
          spmd_endX1 = jmax-2-spmdX3
        ENDIF
        spmd_stepX1 = 1
        spmdX4 = mod(ORG_RANK,2)
        spmdX5 = 129*spmdX4
        IF (spmdX4.LE.0) THEN
          spmd_startX2 = 1-spmdX5
        ELSE
          spmd_startX2 = 0
        ENDIF
        IF (spmdX4.LT.(imax-2)/129) THEN
          spmd_endX2 = 128
        ELSE
          spmd_endX2 = imax-2-spmdX5
        ENDIF
        spmd_stepX2 = 1
        CALL MPI_Comm_split(MPI_COMM_WORLD,(mod(ORG_RANK,2))+2*((mod(ORG&
     &_RANK,4))/2),ORG_RANK,new_commX0,ierrX4)
        gosaX0 = gosa
        gosa = 0.0e0
        DO k=spmd_startX0,spmd_endX0,1
          DO j=spmd_startX1,spmd_endX1,1
            DO i=spmd_startX2,spmd_endX2,1
              s0 = a(i,j,k,1)*p(i+1,j,k)+a(i,j,k,2)*p(i,j+1,k)+a(i,j,k,3&
     &)*p(i,j,k+1)+b(i,j,k,1)*(p(i+1,j+1,k)-p(i+1,j-1,k)-p(i-1,j+1,k)+p(&
     &i-1,j-1,k))+b(i,j,k,2)*(p(i,j+1,k+1)-p(i,j-1,k+1)-p(i,j+1,k-1)+p(i&
     &,j-1,k-1))+b(i,j,k,3)*(p(i+1,j,k+1)-p(i-1,j,k+1)-p(i+1,j,k-1)+p(i-&
     &1,j,k-1))+c(i,j,k,1)*p(i-1,j,k)+c(i,j,k,2)*p(i,j-1,k)+c(i,j,k,3)*p&
     &(i,j,k-1)+wrk1(i,j,k)
              ss = (s0*a(i,j,k,4)-p(i,j,k))*bnd(i,j,k)
              gosa = gosa+ss*ss
              wrk2(i,j,k) = p(i,j,k)+omega*ss
            ENDDO
          ENDDO
        ENDDO
        CALL MPI_Allreduce(gosa,recvbufX0,1,MPI_REAL4,MPI_SUM,MPI_COMM_W&
     &ORLD,ierrX4)
        gosa = gosaX0+recvbufX0
        CALL MPI_Comm_free(new_commX0,ierrX5)
        spmdX6 = (mod(ORG_RANK,16))/4
        spmdX7 = 33*spmdX6
        IF (spmdX6.LE.0) THEN
          spmd_startX3 = 1-spmdX7
        ELSE
          spmd_startX3 = 0
        ENDIF
        IF (spmdX6.LT.(kmax-2)/33) THEN
          spmd_endX3 = 32
        ELSE
          spmd_endX3 = kmax-2-spmdX7
        ENDIF
        spmd_stepX3 = 1
        spmdX8 = (mod(ORG_RANK,4))/2
        spmdX9 = 65*spmdX8
        IF (spmdX8.LE.0) THEN
          spmd_startX4 = 1-spmdX9
        ELSE
          spmd_startX4 = 0
        ENDIF
        IF (spmdX8.LT.(jmax-2)/65) THEN
          spmd_endX4 = 64
        ELSE
          spmd_endX4 = jmax-2-spmdX9
        ENDIF
        spmd_stepX4 = 1
        spmdX10 = mod(ORG_RANK,2)
        spmdX11 = 129*spmdX10
        IF (spmdX10.LE.0) THEN
          spmd_startX5 = 1-spmdX11
        ELSE
          spmd_startX5 = 0
        ENDIF
        IF (spmdX10.LT.(imax-2)/129) THEN
          spmd_endX5 = 128
        ELSE
          spmd_endX5 = imax-2-spmdX11
        ENDIF
        spmd_stepX5 = 1
        DO k=spmd_startX3,spmd_endX3,1
          DO j=spmd_startX4,spmd_endX4,1
            DO i=spmd_startX5,spmd_endX5,1
              p(i,j,k) = wrk2(i,j,k)
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END SUBROUTINE
      FUNCTION gdtime(time)
      INCLUDE 'mpif.h'
      REAL(KIND=4):: gdtime
      REAL(KIND=4):: time(1:2)
      REAL(KIND=4):: ldtime(0:0)
      EXTERNAL dtime
      REAL(KIND=4):: dtime
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      REAL(KIND=4):: UTL_tmp001
      INTEGER(KIND=4):: ierrX0
      INTRINSIC mod
      REAL(KIND=4):: ldtimeX0
      INTEGER(KIND=4):: ierrX1
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      UTL_tmp001 = dtime(time)
      IF (0.EQ.ORG_RANK) ldtime(mod(0,1)) = UTL_tmp001
      IF (ORG_RANK.EQ.0) ldtimeX0 = ldtime(mod(0,1))
      CALL MPI_Bcast(ldtimeX0,1,MPI_REAL4,0,MPI_COMM_WORLD,ierrX1)
      gdtime = ldtimeX0
      RETURN
      END FUNCTION
